GEODE: Create CI pipeline for Nordx geode releases

Change-Id: I3541599e54b729f395e5df6a04f98b7482553da0
diff --git a/jjb/geode/apache-geode-build/execute_build.sh b/jjb/geode/apache-geode-build/execute_build.sh
new file mode 100755
index 0000000..8e3a5b6
--- /dev/null
+++ b/jjb/geode/apache-geode-build/execute_build.sh
@@ -0,0 +1,92 @@
+#!/usr/bin/env bash
+#
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements.  See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership.  The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License.  You may obtain a copy of the License at
+#
+#     http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+set -e
+
+BASE_DIR=$(pwd)
+
+SOURCE="${BASH_SOURCE[0]}"
+while [ -h "$SOURCE" ]; do # resolve $SOURCE until the file is no longer a symlink
+  SCRIPTDIR="$( cd -P "$( dirname "$SOURCE" )" && pwd )"
+  SOURCE="$(readlink "$SOURCE")"
+  [[ $SOURCE != /* ]] && SOURCE="$DIR/$SOURCE" # if $SOURCE was a relative symlink, we need to resolve it relative to the path where the symlink file was located
+done
+SCRIPTDIR="$( cd -P "$( dirname "$SOURCE" )" && pwd )"
+source ${BASE_DIR}/geode/ci/scripts/shared_utilities.sh
+
+if [[ -z "${GRADLE_TASK}" ]]; then
+  echo "GRADLE_TASK must be set. exiting..."
+  exit 1
+fi
+
+ROOT_DIR=$(pwd)
+BUILD_DATE=$(date +%s)
+
+# Precheckin does not get a geode-build-version
+if [ -e "${ROOT_DIR}/geode-build-version" ] ; then
+  GEODE_BUILD_VERSION_FILE=${ROOT_DIR}/geode-build-version/number
+  GEODE_BUILD_DIR=/tmp/geode-build
+  GEODE_PULL_REQUEST_ID_FILE=${ROOT_DIR}/geode/.git/resource/version.json
+
+  if [ -e "${GEODE_PULL_REQUEST_ID_FILE}" ]; then
+    GEODE_PULL_REQUEST_ID=$(cat ${GEODE_PULL_REQUEST_ID_FILE} | jq --raw-output '.["pr"]')
+    FULL_PRODUCT_VERSION="geode-pr-${GEODE_PULL_REQUEST_ID}"
+  else
+    GEODE_VERSION=$(cat ${GEODE_BUILD_VERSION_FILE} | cut -d'-' -f1)
+    echo -e "\nGEODE VERSION is ${GEODE_VERSION}"
+    BUILD_ID=$(cat ${GEODE_BUILD_VERSION_FILE} | cut -d'.' -f4)
+    FULL_PRODUCT_VERSION=$(cat ${GEODE_BUILD_VERSION_FILE})
+    echo -e "FULL PRODUCT VERSION is ${FULL_PRODUCT_VERSION}\n"
+  fi
+fi
+
+if [[ ${PARALLEL_GRADLE:-"true"} == "true" ]]; then
+  PARALLEL_GRADLE="--parallel"
+else
+  PARALLEL_GRADLE=""
+fi
+DEFAULT_GRADLE_TASK_OPTIONS="${PARALLEL_GRADLE} --console=plain --no-daemon"
+GRADLE_SKIP_TASK_OPTIONS=""
+
+if [[ -n "${PARALLEL_DUNIT}" && "${PARALLEL_DUNIT}" == "true" ]]; then
+  PARALLEL_DUNIT="-PparallelDunit -PdunitDockerUser=geode"
+  if [ -n "${DUNIT_PARALLEL_FORKS}" ]; then
+    DUNIT_PARALLEL_FORKS="-PdunitParallelForks=${DUNIT_PARALLEL_FORKS}"
+  fi
+else
+  PARALLEL_DUNIT=""
+  DUNIT_PARALLEL_FORKS=""
+fi
+
+SET_JAVA_HOME="export JAVA_HOME=/usr/lib/jvm/java-${JAVA_BUILD_VERSION}-openjdk-amd64"
+
+if [ -z "${FULL_PRODUCT_VERSION}" ] ; then
+  FULL_PRODUCT_VERSION="0.0.0-UndefinedVersion"
+fi
+
+GRADLE_ARGS="\
+    ${DEFAULT_GRADLE_TASK_OPTIONS} \
+    ${GRADLE_SKIP_TASK_OPTIONS} \
+    ${GRADLE_GLOBAL_ARGS} \
+    -Pversion=${FULL_PRODUCT_VERSION} \
+    -PbuildId=${BUILD_ID} \
+    build install javadoc spotlessCheck rat checkPom resolveDependencies -x test"
+
+EXEC_COMMAND="mkdir -p tmp && cd geode && ${SET_JAVA_HOME} && ./gradlew ${GRADLE_ARGS}"
+echo "${EXEC_COMMAND}"
+eval ${EXEC_COMMAND}